﻿using System;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using UnivateProperties_API.Containers;

namespace UnivateProperties_API.Model
{
    public abstract class BaseEntity
    {
        #region Properties
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        [Key]
        public int Id { get; set; }
        public DateTime Created { get; set; } = DateTime.Now;
        public DateTime Modified { get; set; } = DateTime.Now;
        public string ModifiedBy { get; set; }
        [NotMapped]
        public ValidateEntity Valid { get; set; }
        #endregion

        #region Methods
        public virtual void UpdateModified(string modifiedBy)
        {
            Modified = DateTime.Now;
            if (string.IsNullOrEmpty(modifiedBy))
            {
                ModifiedBy = modifiedBy;
            }
        }

        public void Validate()
        {
            Valid = ValidateObject();
        }

        public virtual ValidateEntity ValidateObject()
        {
            ValidateEntity v = new ValidateEntity();
            return v;
        }
        #endregion Methods
    }
}
