﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using UnivateProperties_API.Context;
using UnivateProperties_API.Helpers;
using UnivateProperties_API.Model.Users;

namespace UnivateProperties_API.Repository.Users
{
    public class AgentRepository : IRepository<Agent>
    {
        private readonly DataContext _dbContext;

        public AgentRepository(DataContext dbContext)
        {
            _dbContext = dbContext;
        }

        public List<Agent> Get(Func<Agent, bool> where)
        {
            return _dbContext.Agents.Where(where).ToList();
        }

        public List<Agent> GetAll()
        {
            return _dbContext.Agents.ToList();
        }

        public Agent GetDetailed(Func<Agent, bool> first)
        {

            var item = _dbContext.Agents.FirstOrDefault(first);
            //AgentRepository account = new AgentRepository(_dbContext);
            //item = GetDetailedObject(item, account);
            return item;
        }

        private Agent GetDetailedObject(Agent item, AgentRepository repo)
        {
            item = repo.GetDetailed(x => x.Id == item.Id);
            return item;
        }

        public void Insert(Agent item)
        {
            _dbContext.Add(item);
            Save();
        }

        public void Insert(IEnumerable<Agent> item)
        {
            foreach (var i in item)
            {
                _dbContext.Add(item);
            }
            Save();
        }

        public void Remove(Agent item)
        {
            var i = _dbContext.Agents.Find(item);
            _dbContext.Agents.Remove(i);
            Save();
        }

        public void Remove(IEnumerable<Agent> items)
        {
            foreach (var item in items)
            {
                Agent i = _dbContext.Agents.Find(item);
                _dbContext.Agents.Remove(i);
            }
            Save();
        }

        public void RemoveAtId(int item)
        {
            var i = _dbContext.Agents.Find(item);
            _dbContext.Agents.Remove(i);
            Save();
        }

        public void Update(Agent item)
        {
            _dbContext.Entry(item).State = EntityState.Modified;
            Save();
        }

        public void Save()
        {
            _dbContext.SaveChanges();
        }

        public List<Agent> GetDetailedAll()
        {
            // TODO: GetDetailed
            throw new NotImplementedException();
        }
    }
}
